unit solutil;

interface

uses Controls, DateUtils, comobj, VARIANTS, ShellAPI, forms,
  Windows, Messages, SysUtils, Classes, Graphics, Dialogs,
  ShlObj, winsock, strutils, registry;

type
  TSolUtil = class(TComponent)
  private
    DStartDir: string;

    function getstartdir: string;

  public
    function WeekDayof(day: tdate): string;
    function NameofMonth(day: tdate): string;
    procedure ParseData(linein: string; var cmd: string; var a: string; var b: string; var c: string; var d: string);
    function CurrentUserName: string;
    function CurrentHostName: string;
    procedure GetHostInfo(var Name, Address: string);
    function TextEnCrypt(normal: string): string;
    function textdecrypt(crypted: string): string;
    procedure SeparateData(linein: string; delimiter: string; var a: string; var b: string; var c: string; var d: string; var e: string);
    function ExecNewProcess(ProgramName: string; Wait: Boolean; aShow: Boolean): boolean;
    function CompactAndRepair(DB, pwd: string): boolean;
    function ExecuteFileWait(ExecuteFile, ParamString, StartInDir: string; Show: Boolean): string;
    function ReadCommandLine(parmname: string; var value: string): Boolean;
    function Get_MacAddress: string;
    function FillZeros(intext: string; maxlength: integer; leading: boolean): string;
    function ChartoCode(input: string): string;
    function CodetoChar(input: string): string;
    procedure BlockInput(ABlockInput: boolean); stdcall;
    procedure KillAllProcessesof(exename: string);
    function KillProcess(exename: string): boolean;
    function RunningProcessesList(List: TStrings): Boolean;
    function processExists(exeFileName: string): Boolean;
    function BuildSessionID:String;
    function RemoveNonLettersNumbers(intext: string): string;
    function GetDomainName: string;
  published
    property StartDir: string read getstartdir;
  end;



procedure Register;


implementation

uses TlHelp32, PsApi;

procedure Register;
begin
  RegisterComponents('FreeMEG', [TSolUtil]);
end;


function tsolutil.GetDomainName:string;
var
   fSuccess : boolean;
   hToken   : THandle;
   ptiUser  : PSIDAndAttributes;
   cbti     : DWORD;
   snu      : SID_NAME_USE;
   szUser : PChar;
   pcchUser : DWORD;
   szDomain : PChar;
   pcchDomain: DWORD;

begin
   ptiUser := nil;
              showmessage('here');

   try
      // Get the calling thread's access token.
      if (not OpenThreadToken(GetCurrentThread(), TOKEN_QUERY, TRUE,
            hToken)) then

       begin
         if (GetLastError() <> ERROR_NO_TOKEN) then
            exit;

         // Retry against process token if no thread token exists.
         if (not OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY,
               hToken)) then
            exit;
       end;

      // Obtain the size of the user information in the token.
      if (GetTokenInformation(hToken, TokenUser, nil, 0, cbti)) then

         // Call should have failed due to zero-length buffer.
         Exit

       else

         // Call should have failed due to zero-length buffer.
         if (GetLastError() <> ERROR_INSUFFICIENT_BUFFER) then
            Exit;


      // Allocate buffer for user information in the token.
      ptiUser :=  HeapAlloc(GetProcessHeap(), 0, cbti);
      if (ptiUser= nil) then
         Exit;

      // Retrieve the user information from the token.
      if ( not GetTokenInformation(hToken, TokenUser, ptiUser, cbti, cbti)) then
         Exit;

      // Retrieve user name and domain name based on user's SID.
      if ( not LookupAccountSid(nil, ptiUser.Sid, szUser, pcchUser,
            szDomain, pcchDomain, snu)) then
         Exit;

      fSuccess := TRUE;

   finally

      // Free resources.
      if (hToken > 0) then
         CloseHandle(hToken);

      if (ptiUser <> nil) then
         HeapFree(GetProcessHeap(), 0, ptiUser);

   end;
          showmessage('here');
         Result := String(szDomain);
end;





function tSolutil.RemoveNonLettersNumbers(intext: string): string;
{Removes anything not a letter or number from a string}
{Returns modified intext}
var allowedText: string;
  dummy: string;
  i: integer;
begin
  allowedText := 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890';
  dummy := '';
  for i := 0 to length(intext) do
  begin
    if AnsiCOntainsStr(allowedtext, intext[i]) then dummy := dummy + intext[i];
  end;
  result := dummy;

end;




function tSolutil.BuildSessionID:String;
var i:integer;
    temps:string;
    scopes:String;
begin
     Randomize;
     scopes := '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ';

     temps := '';

     i := 1;
     While i <= 50 do
     begin
          temps := temps + Copy(scopes,Random(length(scopes)),1);

          inc(i);
     end;
     
    BuildSessionID :=  temps;

end;

procedure Tsolutil.BlockInput(ABlockInput: boolean); stdcall; external 'USER32.DLL';

function TSolutil.ReadCommandLine(parmname: string; var value: string): Boolean;
var i: integer;
begin
  ReadCommandLine := False;
  for i := 0 to paramcount do
  begin
    if uppercase(copy(paramstr(i), 0, length(parmname) + 2)) = '/' + uppercase(parmname) + ':' then
    begin
      value := copy(paramstr(i), length(parmname) + 3, length(paramstr(i)) - length(parmname) + 2);
      ReadCommandLine := true;
    end
    else
      if uppercase(copy(paramstr(i), 0, length(parmname) + 1)) = '/' + uppercase(parmname) then ReadCommandLine := true;
  end;
end;

function TSolutil.ExecuteFileWait(ExecuteFile, ParamString, StartInDir: string; Show: Boolean): string;
var
  SEInfo: TShellExecuteInfo;
  ExitCode: DWORD;

begin
  FillChar(SEInfo, SizeOf(SEInfo), 0);
  SEInfo.cbSize := SizeOf(TShellExecuteInfo);
  with SEInfo do begin
    fMask := SEE_MASK_NOCLOSEPROCESS;
    Wnd := Application.Handle;
    lpFile := PChar(ExecuteFile);
{
ParamString can contain the
application parameters.
}
    lpParameters := PChar(ParamString);
{
StartInString specifies the
name of the working directory.
If ommited, the current directory is used.
}
    lpDirectory := PChar(StartInDir);
    if SHOW then nShow := SW_SHOWNORMAL else nSHOW := SW_HIDE
  end;
  if ShellExecuteEx(@SEInfo) then begin
    repeat
      Application.ProcessMessages;
      GetExitCodeProcess(SEInfo.hProcess, ExitCode);
    until (ExitCode <> STILL_ACTIVE) or
      Application.Terminated;
  end;
end;



// Compact and repair an access database, it requires exclusive db access.
// argument DB = Path to Access Database

function TSolutil.CompactAndRepair(DB, pwd: string): boolean;
var
  v: OLEvariant;
begin { CompactAndRepair }
  Result := True;
  try
    v := CreateOLEObject('JRO.JetEngine');
    try
      v.CompactDatabase('Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + DB + ';Jet OLEDB:Database Password=' + pwd,
        'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + DB +
        'x;Jet OLEDB:Engine type=5');
      DeleteFile(DB);
      RenameFile(DB + 'x', DB)
    finally
      v := uNASSIGNED
    end; { try }

  except
    Result := False
  end; { try }
end; { CompactAndRepair }



function TSolutil.Get_MacAddress: string;
var
  Lib: Cardinal;
  Func: function(GUID: PGUID): Longint; stdcall;
  GUID1, GUID2: TGUID;
begin
  Result := '';
  Lib := LoadLibrary('rpcrt4.dll');
  if Lib <> 0 then
  begin
    @Func := GetProcAddress(Lib, 'UuidCreateSequential');
    if Assigned(Func) then
    begin
      if (Func(@GUID1) = 0) and
        (Func(@GUID2) = 0) and
        (GUID1.D4[2] = GUID2.D4[2]) and
        (GUID1.D4[3] = GUID2.D4[3]) and
        (GUID1.D4[4] = GUID2.D4[4]) and
        (GUID1.D4[5] = GUID2.D4[5]) and
        (GUID1.D4[6] = GUID2.D4[6]) and
        (GUID1.D4[7] = GUID2.D4[7]) then
      begin
        Result :=
          IntToHex(GUID1.D4[2], 2) + '-' +
          IntToHex(GUID1.D4[3], 2) + '-' +
          IntToHex(GUID1.D4[4], 2) + '-' +
          IntToHex(GUID1.D4[5], 2) + '-' +
          IntToHex(GUID1.D4[6], 2) + '-' +
          IntToHex(GUID1.D4[7], 2);
      end;
    end;
  end;
end;

function TSolutil.ExecNewProcess(ProgramName: string; Wait: Boolean; aShow: Boolean): boolean;
var
  StartInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  CreateOK, ok: Boolean;
begin
    { fill with known state }
  FillChar(StartInfo, SizeOf(TStartupInfo), #0);
  FillChar(ProcInfo, SizeOf(TProcessInformation), #0);
  startinfo.dwFlags := STARTF_USESHOWWINDOW;
  if ashow then
  begin

    startinfo.wShowWindow := SW_SHOW;
  end
  else
  begin
    startinfo.wShowWindow := SW_HIDE;
  end;
  StartInfo.cb := SizeOf(TStartupInfo);
  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil, False,
    CREATE_NEW_PROCESS_GROUP + NORMAL_PRIORITY_CLASS,
    nil, nil, StartInfo, ProcInfo);
    { check to see if successful }
  if CreateOK then
  begin
        //may or may not be needed. Usually wait for child processes
    if Wait then
      WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    ok := true;
  end
  else
  begin
    ok := false;
  end;

  CloseHandle(ProcInfo.hProcess);
  CloseHandle(ProcInfo.hThread);

  result := ok;
end;

function TSolutil.WeekDayof(day: tdate): string;
var dayname: string;
begin
  if DayofWeek(day) = 2 then dayname := 'Monday';
  if DayofWeek(day) = 3 then dayname := 'Tuesday';
  if DayofWeek(day) = 4 then dayname := 'Wednesday';
  if DayofWeek(day) = 5 then dayname := 'Thursday';
  if DayofWeek(day) = 6 then dayname := 'Friday';
  if DayofWeek(day) = 7 then dayname := 'Saturday';
  if DayofWeek(day) = 1 then dayname := 'Sunday';

  WeekDayOf := dayname;
end;

function TSolutil.NameofMonth(day: tdate): string;
var MonthName: string;
begin
  if MonthOF(day) = 1 then MonthName := 'January';
  if MonthOF(day) = 2 then MonthName := 'February';
  if MonthOF(day) = 3 then MonthName := 'March';
  if MonthOF(day) = 4 then MonthName := 'April';
  if MonthOF(day) = 5 then MonthName := 'May';
  if MonthOF(day) = 6 then MonthName := 'June';
  if MonthOF(day) = 7 then MonthName := 'July';
  if MonthOF(day) = 8 then MonthName := 'August';
  if MonthOF(day) = 9 then MonthName := 'September';
  if MonthOF(day) = 10 then MonthName := 'October';
  if MonthOF(day) = 11 then MonthName := 'November';
  if MonthOF(day) = 12 then MonthName := 'December';

  NameofMonth := MonthName;
end;


procedure TSolutil.SeparateData(linein: string; delimiter: string; var a: string; var b: string; var c: string; var d: string; var e: string);
var qouteon: boolean;
  i: integer;
  templine: array[1..5] of string;
  tempi: integer;
  ch: string;

begin
  for i := 1 to 5 do templine[i] := '';

  tempi := 1;
  qouteon := false;


  i := 1;

  while I <= length(linein) do
  begin
    ch := linein[i];

    if ((ch = '"') and (not qouteon)) then
    begin
      qouteon := true;
    end
    else
      if ((ch = '"') and (qouteon)) then
      begin
        qouteon := false;
      end
      else
        if ((ch = delimiter) and (not qouteon)) then
        begin
          inc(tempi);
        end
        else
          templine[tempi] := templine[tempi] + ch;

    inc(i);
  end;

  a := templine[1];
  b := templine[2];
  c := templine[3];
  d := templine[4];
  e := templine[5];


end;

procedure TSolutil.ParseData(linein: string; var cmd: string; var a: string; var b: string; var c: string; var d: string);
var qouteon: boolean;
  i: integer;
  templine: array[1..5] of string;
  tempi: integer;
  ch: string;
  dummyvar: string;
begin
  for i := 1 to 5 do templine[i] := '';

  tempi := 1;
  qouteon := false;


  i := 1;

  while I <= length(linein) do
  begin
    ch := linein[i];

    if ((ch = '"') and (not qouteon)) then
    begin
      qouteon := true;
    end
    else
      if ((ch = '"') and (qouteon)) then
      begin
        qouteon := false;
      end
      else
        if ((ch = ' ') and (not qouteon)) then
        begin
          inc(tempi);
        end
        else
          if (ch = '%') then
          begin
            dummyvar := '';
            inc(i);
            while linein[i] <> '%' do
            begin
              dummyvar := dummyvar + linein[i];
              inc(i);
            end;
            ch := dummyvar;
            templine[tempi] := templine[tempi] + ch;
          end
          else
            templine[tempi] := templine[tempi] + ch;

    inc(i);
  end;

  cmd := templine[1];
  a := templine[2];
  b := templine[3];
  c := templine[4];
  d := templine[5];


end;


function TSolutil.TextEnCrypt(normal: string): string;
var i: integer;
  dummy: string;
  key: byte;
begin
  randomize;
  key := random(128);
  dummy := '';
  if normal <> '' then
  begin
    for i := 1 to length(normal) do
    begin
      dummy := dummy + (chr(key + ord(normal[i])));
    end;
  end;
  textencrypt := chr(key) + dummy;
end;

function TSolutil.textdecrypt(crypted: string): string;
var i: integer;
  key: byte;
  dummy: string;
begin
  dummy := '';
  if crypted <> '' then
  begin
    key := ord(crypted[1]);

    for i := 2 to length(crypted) do
    begin
      dummy := dummy + chr(ord(crypted[i]) - key);
    end;
  end;
  textdecrypt := dummy;
end;

function TSolutil.CurrentUserName: string;
var
  u: array[0..127] of Char;
  sz: Dword;
begin
  sz := SizeOf(u);
  GetUserName(u, sz);
  Result := u;
end;

function TSolutil.CurrentHostName: string;
var name, dummy: string;
begin
  GetHostInfo(name, Dummy);
  CurrentHostname := Name;
end;


procedure TSolutil.GetHostInfo(var Name, Address: string);
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
begin
  { no error checking...}
  WSAStartup(2, WSAData);
  SetLength(Name, 255);
  Gethostname(PChar(Name), 255);
  SetLength(Name, StrLen(PChar(Name)));
  HostEnt := gethostbyname(PChar(Name));
  with HostEnt^ do
    Address := Format('%d.%d.%d.%d', [
      Byte(h_addr^[0]),
        Byte(h_addr^[1]),
        Byte(h_addr^[2]),
        Byte(h_addr^[3])]);
  WSACleanup;
end;

function TSolutil.getstartdir: string;
var i, p: word;
begin
  p := 0;
  for i := 1 to length(paramstr(0)) do
  begin
    if paramstr(0)[i] = '\' then p := i;
  end;
  getstartdir := COPY(paramstr(0), 0, p);
end;


function Tsolutil.FillZeros(intext: string; maxlength: integer; leading: boolean): string;
{Adds Zeros to the max length of the intext string. Leading is set true will add zeros to
front of intext, if false will add to end of intext. Returns modified intext}
var
  i: integer;
  dummy: string;
begin

  for i := maxlength downto length(intext) + 1 do
    dummy := dummy + '0';

  if leading then dummy := dummy + intext else dummy := intext + dummy;

  result := dummy;
end;

function Tsolutil.ChartoCode(input: string): string;
var i: integer;
  dummy: string;
begin
  dummy := '';
  for i := 1 to length(input) do
  begin
    dummy := dummy + FillZeros(inttostr(ord(input[i])), 3, true);

  end;
  result := dummy;
end;


function Tsolutil.CodetoChar(input: string): string;
var i: integer;
  dummy: string;
begin
  try
    dummy := '';
    i := 1;
    while i <= length(input) do
    begin
      dummy := dummy + chr(strtoint(copy(input, i, 3)));
      inc(i, 3);
    end;
    result := dummy;
  except
    on e: exception do result := '';

  end;
end;



function tsolutil.processExists(exeFileName: string): Boolean;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
  Result := False;
  while Integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(ExeFileName))) then
    begin
      Result := True;
    end;
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  CloseHandle(FSnapshotHandle);
end;


function Tsolutil.RunningProcessesList(List: TStrings): Boolean;

  function BuildListTH: Boolean;
  var
    SnapProcHandle: THandle;
    ProcEntry: TProcessEntry32;
    NextProc: Boolean;
  begin
    SnapProcHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
    if SnapProcHandle <> THandle(-1) then
    begin
      Result := True;
      ProcEntry.dwSize := Sizeof(ProcEntry);
      NextProc := Process32First(SnapProcHandle, ProcEntry);
      while NextProc do
      begin
        List.AddObject(ProcEntry.szExeFile, Pointer(ProcEntry.th32ProcessID));
        NextProc := Process32Next(SnapProcHandle, ProcEntry);
      end;
      CloseHandle(SnapProcHandle);
    end else
      Result := False;
  end;

  function BuildListPS: Boolean;
  var
    PIDs: array[0..1024] of DWORD;
    Handle: THandle;
    Needed: DWORD;
    I: Integer;
    ModuleFileName: array[0..MAX_PATH] of Char;
  begin
    Result := EnumProcesses(@PIDs, Sizeof(PIDs), Needed);
    if not Result then Exit;
    for I := 0 to (Needed div Sizeof(DWORD)) - 1 do
      if PIDs[I] <> 0 then
      begin
        Handle := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, False, PIDs[I]);
        if Handle <> 0 then
        begin
          if GetModuleFileNameEx(Handle, 0, ModuleFileName, Sizeof(ModuleFileName)) = 0 then
            List.AddObject('[System]', Pointer(INVALID_HANDLE_VALUE))
          else
            List.AddObject(ModuleFileName, Pointer(PIDs[I]));
          CloseHandle(Handle);
        end;
      end;
  end;

begin
  Assert(Assigned(List));
  List.BeginUpdate;
  try
    List.Clear;
    if (Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion = 4) then
      Result := BuildListPS
    else
      Result := BuildListTH;
  finally
    List.EndUpdate;
  end;
end;


function Tsolutil.KillProcess(exename: string): boolean;
var ProcessID: LongWord;
  ProcessHandle: THandle;
  intExitCode: LongWord;
  temp: Tstringlist;
  rresult: boolean;
begin
  rresult := false;
  temp := Tstringlist.create;
  RunningProcesseslist(temp);
  if temp.IndexOf(exename) <> -1 then
  begin
    ProcessID := longword(temp.Objects[temp.IndexOf(exename)]);
    ProcessHandle := OpenProcess(PROCESS_TERMINATE, False, ProcessID);
    GetExitCodeProcess(ProcessHandle, intExitCode);
    TerminateProcess(ProcessHandle, intExitCode);
    CloseHandle(ProcessHandle);
    rresult := true;
  end;
  temp.free;
  KillProcess := rresult;
end;

procedure tsolutil.KillAllProcessesof(exename: string);
begin
  while KillProcess(exename) do ;
end;


begin

end.

